import javax.swing.*;
import java.awt.*;
import java.io.*;

//Class that will log data to screen and to file.
public class Info extends JTextArea
{
   //Whether we log or not
   private boolean logToFile;

   //File output writer
   private BufferedWriter out;

   //Constructs Log object by opening a file and setting label attributes
   public Info(String logfile)
   {
      super ("", 0, 35);

      logToFile = ! logfile.equals("");

      if (logToFile)
         try
         {  out = new BufferedWriter(new FileWriter(logfile));
         }
         catch (Exception e)
         {  System.out.println("Can't open logfile " + logfile);
            System.exit(1);
         }

      setForeground(Color.black);
      setBackground(Color.white);
      setEditable(false);
      setFont(new Font("Monospaced", Font.PLAIN, 14));
   }

   //Sends text to label and to file.
   public void logText(String text)
   {
      int pos = getCaretPosition();
      append((pos > 0 ? "\n" : "") + text);
      setCaretPosition(pos + text.length() + (pos > 0 ? 1 : 0));

      if (logToFile)
         try
         {  out.write(text);
            out.newLine();
         }
         catch (Exception e)
         {  System.out.println("Can't write to logfile");
            System.exit(1);
         }
   }

//closes logfile
   public void closeFile()
   {
      if (logToFile)
         try
           {out.close();}
         catch (Exception e)
           {}
   }
}
